Index: include/avr/iox32a4.h
===================================================================
--- include/avr/iox32a4.h	(revision 2103)
+++ include/avr/iox32a4.h	(working copy)
@@ -2535,13 +2535,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox128a3.h
===================================================================
--- include/avr/iox128a3.h	(revision 2103)
+++ include/avr/iox128a3.h	(working copy)
@@ -2535,13 +2535,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox64a1.h
===================================================================
--- include/avr/iox64a1.h	(revision 2103)
+++ include/avr/iox64a1.h	(working copy)
@@ -2535,13 +2535,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox32d4.h
===================================================================
--- include/avr/iox32d4.h	(revision 2103)
+++ include/avr/iox32d4.h	(working copy)
@@ -2150,13 +2150,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox128d3.h
===================================================================
--- include/avr/iox128d3.h	(revision 2103)
+++ include/avr/iox128d3.h	(working copy)
@@ -2150,13 +2150,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox192a3.h
===================================================================
--- include/avr/iox192a3.h	(revision 2103)
+++ include/avr/iox192a3.h	(working copy)
@@ -2535,13 +2535,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox128a1.h
===================================================================
--- include/avr/iox128a1.h	(revision 2103)
+++ include/avr/iox128a1.h	(working copy)
@@ -154,21 +154,6 @@
 --------------------------------------------------------------------------
 */
 
-/* Clock System */
-typedef struct CLK_struct
-{
-    register8_t CTRL;  /* Control Register */
-    register8_t PSCTRL;  /* Prescaler Control Register */
-    register8_t LOCK;  /* Lock register */
-    register8_t RTCCTRL;  /* RTC Control Register */
-} CLK_t;
-
-/*
---------------------------------------------------------------------------
-CLK - Clock System
---------------------------------------------------------------------------
-*/
-
 /* Power Reduction */
 typedef struct PR_struct
 {
@@ -2535,13 +2520,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox192d3.h
===================================================================
--- include/avr/iox192d3.h	(revision 2103)
+++ include/avr/iox192d3.h	(working copy)
@@ -2150,13 +2150,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox64a3.h
===================================================================
--- include/avr/iox64a3.h	(revision 2103)
+++ include/avr/iox64a3.h	(working copy)
@@ -2535,13 +2535,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox256a3.h
===================================================================
--- include/avr/iox256a3.h	(revision 2103)
+++ include/avr/iox256a3.h	(working copy)
@@ -2535,13 +2535,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox256a3b.h
===================================================================
--- include/avr/iox256a3b.h	(revision 2103)
+++ include/avr/iox256a3b.h	(working copy)
@@ -2531,13 +2531,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox16a4.h
===================================================================
--- include/avr/iox16a4.h	(revision 2103)
+++ include/avr/iox16a4.h	(working copy)
@@ -2535,13 +2535,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox64d3.h
===================================================================
--- include/avr/iox64d3.h	(revision 2103)
+++ include/avr/iox64d3.h	(working copy)
@@ -2150,13 +2150,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox256d3.h
===================================================================
--- include/avr/iox256d3.h	(revision 2103)
+++ include/avr/iox256d3.h	(working copy)
@@ -2121,13 +2121,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox16d4.h
===================================================================
--- include/avr/iox16d4.h	(revision 2103)
+++ include/avr/iox16d4.h	(working copy)
@@ -2150,13 +2150,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox128a1u.h
===================================================================
--- include/avr/iox128a1u.h	(revision 2103)
+++ include/avr/iox128a1u.h	(working copy)
@@ -2622,13 +2622,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: ChangeLog
===================================================================
--- ChangeLog	(revision 2103)
+++ ChangeLog	(working copy)
@@ -1,3 +1,23 @@
+2010-03-31  Anitha Boyapati <anitha.boyapati@atmel.com>
+
+	Fix bug #28901.
+	* include/avr/iox128a1.h - Removed GPIO and CPU memory map entries
+	* include/avr/iox128a1u.h - Removed GPIO and CPU memory map entries
+	* include/avr/iox128a3.h - Removed GPIO and CPU memory map entries
+	* include/avr/iox128d3.h - Removed GPIO and CPU memory map entries
+	* include/avr/iox16a4.h - Removed GPIO and CPU memory map entries
+	* include/avr/iox16d4.h - Removed GPIO and CPU memory map entries
+	* include/avr/iox192a3.h - Removed GPIO and CPU memory map entries
+	* include/avr/iox192d3.h - Removed GPIO and CPU memory map entries
+	* include/avr/iox256a3.h - Removed GPIO and CPU memory map entries
+	* include/avr/iox256a3b.h - Removed GPIO and CPU memory map entries
+	* include/avr/iox256d3.h - Removed GPIO and CPU memory map entries
+	* include/avr/iox32a4.h - Removed GPIO and CPU memory map entries
+	* include/avr/iox32d4.h - Removed GPIO and CPU memory map entries
+	* include/avr/iox64a1.h - Removed GPIO and CPU memory map entries
+	* include/avr/iox64a3.h - Removed GPIO and CPU memory map entries
+	* include/avr/iox64d3.h - Removed GPIO and CPU memory map entries
+
 2010-03-11  Eric B. Weddington  <eric.weddington@atmel.com>
 
 	Fix bug #28575.
Index: NEWS
===================================================================
--- NEWS	(revision 2103)
+++ NEWS	(working copy)
@@ -108,6 +108,7 @@
   [#28688] using_tools.dox fails to build due to extra underscore
   [#28756] Bug in AVR libc 1.6.7 (power.h for 8-bit AVR)
   [#28812] iotn48.h TWS# bits off by one
+  [#28901] iox*.h are modified as a part of bug28901 fix
 
 * Other changes:
 