Index: include/avr/iox32a4.h
===================================================================
--- include/avr/iox32a4.h	(revision 2114)
+++ include/avr/iox32a4.h	(working copy)
@@ -2535,13 +2535,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox128a3.h
===================================================================
--- include/avr/iox128a3.h	(revision 2114)
+++ include/avr/iox128a3.h	(working copy)
@@ -2535,13 +2535,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox64a1.h
===================================================================
--- include/avr/iox64a1.h	(revision 2114)
+++ include/avr/iox64a1.h	(working copy)
@@ -2535,13 +2535,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox32d4.h
===================================================================
--- include/avr/iox32d4.h	(revision 2114)
+++ include/avr/iox32d4.h	(working copy)
@@ -2150,13 +2150,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox128d3.h
===================================================================
--- include/avr/iox128d3.h	(revision 2114)
+++ include/avr/iox128d3.h	(working copy)
@@ -2150,13 +2150,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox64a1u.h
===================================================================
--- include/avr/iox64a1u.h	(revision 2114)
+++ include/avr/iox64a1u.h	(working copy)
@@ -2622,13 +2622,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox192a3.h
===================================================================
--- include/avr/iox192a3.h	(revision 2114)
+++ include/avr/iox192a3.h	(working copy)
@@ -2535,13 +2535,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox128a1.h
===================================================================
--- include/avr/iox128a1.h	(revision 2114)
+++ include/avr/iox128a1.h	(working copy)
@@ -2535,13 +2535,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox192d3.h
===================================================================
--- include/avr/iox192d3.h	(revision 2114)
+++ include/avr/iox192d3.h	(working copy)
@@ -2150,13 +2150,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox64a3.h
===================================================================
--- include/avr/iox64a3.h	(revision 2114)
+++ include/avr/iox64a3.h	(working copy)
@@ -2535,13 +2535,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox256a3.h
===================================================================
--- include/avr/iox256a3.h	(revision 2114)
+++ include/avr/iox256a3.h	(working copy)
@@ -2535,13 +2535,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox256a3b.h
===================================================================
--- include/avr/iox256a3b.h	(revision 2114)
+++ include/avr/iox256a3b.h	(working copy)
@@ -2531,13 +2531,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox16a4.h
===================================================================
--- include/avr/iox16a4.h	(revision 2114)
+++ include/avr/iox16a4.h	(working copy)
@@ -2535,13 +2535,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox64d3.h
===================================================================
--- include/avr/iox64d3.h	(revision 2114)
+++ include/avr/iox64d3.h	(working copy)
@@ -2150,13 +2150,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox256d3.h
===================================================================
--- include/avr/iox256d3.h	(revision 2114)
+++ include/avr/iox256d3.h	(working copy)
@@ -2121,13 +2121,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox16d4.h
===================================================================
--- include/avr/iox16d4.h	(revision 2114)
+++ include/avr/iox16d4.h	(working copy)
@@ -2150,13 +2150,11 @@
 ==========================================================================
 */
 
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: include/avr/iox128a1u.h
===================================================================
--- include/avr/iox128a1u.h	(revision 2114)
+++ include/avr/iox128a1u.h	(working copy)
@@ -2623,13 +2623,11 @@
 */
 
 #define USB_EP_TABLE    (*(USB_EP_TABLE_t *) )  /* Universal Serial Bus Module */
-#define GPIO    (*(GPIO_t *) 0x0000)  /* General Purpose IO Registers */
 #define VPORT0    (*(VPORT_t *) 0x0010)  /* Virtual Port 0 */
 #define VPORT1    (*(VPORT_t *) 0x0014)  /* Virtual Port 1 */
 #define VPORT2    (*(VPORT_t *) 0x0018)  /* Virtual Port 2 */
 #define VPORT3    (*(VPORT_t *) 0x001C)  /* Virtual Port 3 */
 #define OCD    (*(OCD_t *) 0x002E)  /* On-Chip Debug System */
-#define CPU    (*(CPU_t *) 0x0030)  /* CPU Registers */
 #define CLK    (*(CLK_t *) 0x0040)  /* Clock System */
 #define SLEEP    (*(SLEEP_t *) 0x0048)  /* Sleep Controller */
 #define OSC    (*(OSC_t *) 0x0050)  /* Oscillator Control */
Index: ChangeLog
===================================================================
--- ChangeLog	(revision 2114)
+++ ChangeLog	(working copy)
@@ -1,3 +1,23 @@
+2010-03-31  Anitha Boyapati <anitha.boyapati@atmel.com>
+
+        Fix bug #28901.
+        * include/avr/iox128a1.h - Removed GPIO and CPU memory map entries.
+        * include/avr/iox128a1u.h - Same.
+        * include/avr/iox128a3.h - Same.
+        * include/avr/iox128d3.h - Same.
+        * include/avr/iox16a4.h - Same.
+        * include/avr/iox16d4.h - Same.
+        * include/avr/iox192a3.h - Same.
+        * include/avr/iox192d3.h - Same.
+        * include/avr/iox256a3.h - Same.
+        * include/avr/iox256a3b.h - Same.
+        * include/avr/iox256d3.h - Same.
+        * include/avr/iox32a4.h - Same.
+        * include/avr/iox32d4.h - Same.
+        * include/avr/iox64a1.h - Same.
+        * include/avr/iox64a3.h - Same.
+        * include/avr/iox64d3.h - Same.
+
 2010-03-30  Eric B. Weddington  <eric.weddington@atmel.com>
 
 	* crt1/gcrt1.S: Add more interrupt vectors to cover the ATxmega128A1U
Index: NEWS
===================================================================
--- NEWS	(revision 2114)
+++ NEWS	(working copy)
@@ -108,7 +108,9 @@
   [#28688] using_tools.dox fails to build due to extra underscore
   [#28756] Bug in AVR libc 1.6.7 (power.h for 8-bit AVR)
   [#28812] iotn48.h TWS# bits off by one
+  [#28901] Xmega header files with missing definitions for GPIO_t and CPU_t
 
+
 * Other changes:
 
   - Added 'avr35' architecture. Now 'MOVW' and 'LPM Rx, Z[+]' instructions