diff --git a/src/plugins/irc/irc-bar-item.c b/src/plugins/irc/irc-bar-item.c
index 48f647d..a834e87 100644
--- a/src/plugins/irc/irc-bar-item.c
+++ b/src/plugins/irc/irc-bar-item.c
@@ -317,6 +317,19 @@ irc_bar_item_buffer_modes (void *data, struct t_gui_bar_item *item,
                 }
             }
         }
+        if (weechat_config_boolean (irc_config_look_item_channel_modes_hide_flood_control))
+        {
+            pos_space = strchr(channel->modes, ' ');
+            if (pos_space)
+            {
+                pos_key = strchr(channel->modes, 'f');
+                if (pos_key && (pos_key < pos_space))
+                {
+                    modes_without_args = weechat_strndup (channel->modes,
+                                                          pos_space - channel->modes);
+                }
+            }
+        }
         snprintf (modes, sizeof (modes),
                   "%s%s",
                   IRC_COLOR_ITEM_CHANNEL_MODES,
diff --git a/src/plugins/irc/irc-config.c b/src/plugins/irc/irc-config.c
index ff4773a..963aa55 100644
--- a/src/plugins/irc/irc-config.c
+++ b/src/plugins/irc/irc-config.c
@@ -79,6 +79,7 @@ struct t_config_option *irc_config_look_display_pv_away_once;
 struct t_config_option *irc_config_look_display_pv_back;
 struct t_config_option *irc_config_look_item_away_message;
 struct t_config_option *irc_config_look_item_channel_modes_hide_key;
+struct t_config_option *irc_config_look_item_channel_modes_hide_flood_control;
 struct t_config_option *irc_config_look_item_nick_modes;
 struct t_config_option *irc_config_look_item_nick_prefix;
 struct t_config_option *irc_config_look_hide_nickserv_pwd;
@@ -353,6 +354,24 @@ irc_config_change_look_item_channel_modes_hide_key (void *data,
 }
 
 /*
+ * irc_config_change_look_item_channel_modes_hide_flood_control: called when the
+ *                                                             "display channel modes
+ *                                                             hide flood control" option is
+ *                                                             changed
+ */
+
+void
+irc_config_change_look_item_channel_modes_hide_flood_control (void *data,
+                                                              struct t_config_option *option)
+{
+    /* make C compiler happy */
+    (void) data;
+    (void) option;
+
+    weechat_bar_item_update ("buffer_modes");
+}
+
+/*
  * irc_config_change_look_item_nick_modes: called when the "display nick modes"
  *                                         option is changed
  */
@@ -2191,6 +2210,13 @@ irc_config_init ()
            "arguments if mode +k is set on channel)"),
         NULL, 0, 0, "off", NULL, 0, NULL, NULL,
         &irc_config_change_look_item_channel_modes_hide_key, NULL, NULL, NULL);
+    irc_config_look_item_channel_modes_hide_flood_control = weechat_config_new_option (
+        irc_config_file, ptr_section,
+        "item_channel_modes_hide_flood_control", "boolean",
+        N_("hide flood control in channel modes (this will hide all channel modes "
+           "arguments if mode +f is set on channel)"),
+        NULL, 0, 0, "off", NULL, 0, NULL, NULL,
+        &irc_config_change_look_item_channel_modes_hide_flood_control, NULL, NULL, NULL);
     irc_config_look_item_nick_modes = weechat_config_new_option (
         irc_config_file, ptr_section,
         "item_nick_modes", "boolean",
diff --git a/src/plugins/irc/irc-config.h b/src/plugins/irc/irc-config.h
index cdc95c2..918f381 100644
--- a/src/plugins/irc/irc-config.h
+++ b/src/plugins/irc/irc-config.h
@@ -112,6 +112,7 @@ extern struct t_config_option *irc_config_look_display_pv_away_once;
 extern struct t_config_option *irc_config_look_display_pv_back;
 extern struct t_config_option *irc_config_look_item_away_message;
 extern struct t_config_option *irc_config_look_item_channel_modes_hide_key;
+extern struct t_config_option *irc_config_look_item_channel_modes_hide_flood_control;
 extern struct t_config_option *irc_config_look_item_nick_modes;
 extern struct t_config_option *irc_config_look_item_nick_prefix;
 extern struct t_config_option *irc_config_look_hide_nickserv_pwd;